#!/usr/bin/env python
    
# example base.py
import pygtk
pygtk.require('2.0')
import mounts
import gtk
import arrows
import picoData
import picoLowLevel
import numarray as PicoLib  
import sys
import indicators
	
class Base(picoLowLevel.PicoControl):
	
	# End program on close
	def delete_event(self, widget,event, data=None):
		print "delete event occurred"
		return False

	def destroy(self, widget, data=None):
		#picoLowLevel.PicoControl.__del__(self)
		print "destroy signal occurred"
		gtk.main_quit
		sys.exit()
		return False
	
	def __init__(self):
		self.firsttime = True
		self.xpos = 0
		self.ypos = 0
		self.mode = 'control'
		self.count = 1
		self.ycol = 'black'
		self.xcol = 'black'
		# Start GUI Assembly
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.button = gtk.Button()
		self.table = gtk.Table()
		self.window.set_title("CHAMP Picomotor Control")
		self.window.connect("delete_event", self.delete_event)
		self.window.connect("destroy", self.destroy)	
		self.window.set_border_width(10)
		
		table = gtk.Table(2,4 , False)
        	self.window.add(table)
		self.window.show()
		box = gtk.VBox(False, 0)
		box2 = gtk.VBox(False, 0)

		#Overhead Menu
		file_menu = gtk.Menu()
		quit = gtk.MenuItem("Quit")
		#mode = gtk.MenuItem("Mode")
		#joymap = gtk.MenuItem("Joystick Mapping")
		#control = gtk.MenuItem("Control")
		#mode_menu = gtk.Menu()
		#mode_menu.append(joymap)
		#mode_menu.append(control)
		
		#mode.set_submenu(mode_menu)		

		#file_menu.append(mode)
		file_menu.append(quit)

		# Menu Bar Callbacks
		quit.connect("activate",self.destroy)
		quit.connect("activate", self.delete_event)
		#joymap.connect("activate", self.mode_change, 'joy')
		#control.connect("activate", self.mode_change, 'cont')


		quit.show()
		menu_bar = gtk.MenuBar()
		table.attach(menu_bar, 0,4,0,1, gtk.FILL, gtk.FILL,0,0);
		menu_bar.show()
		top_menu = gtk.MenuItem("Menu")
		top_menu.show()
		top_menu.set_submenu(file_menu)
		menu_bar.append(top_menu)
		
		self.mount_buttons, x_pos, y_pos = self.create_mount_buttons()
		
		# Button for F-T.6
		self.mount_buttons[0].connect("clicked", self.mounts_callback,0)
		box.pack_start(self.mount_buttons[0], False, False, 0)
		self.mount_buttons[0].show()

		# Button for F-T.1
		self.mount_buttons[1].connect("clicked", self.mounts_callback,1)
		box.pack_start(self.mount_buttons[1], False, False, 0)
		self.mount_buttons[1].show()

		# Button for F-T.2
		self.mount_buttons[2].connect("clicked", self.mounts_callback,2)
		box.pack_start(self.mount_buttons[2], False, False, 0)
		self.mount_buttons[2].show()

		# Button for F-T.3
		self.mount_buttons[3].connect("clicked", self.mounts_callback,3)
		box.pack_start(self.mount_buttons[3], False, False, 0)
		self.mount_buttons[3].show()

		# Button for F-T.4
		self.mount_buttons[4].connect("clicked", self.mounts_callback,4)
		box.pack_start(self.mount_buttons[4], False, False, 0)
		self.mount_buttons[4].show()

		# Button for F-T.5
		self.mount_buttons[5].connect("clicked", self.mounts_callback,5)
		box.pack_start(self.mount_buttons[5], False, False, 0)
		self.mount_buttons[5].show()

		# Button for BC.6,1
		self.mount_buttons[6].connect("clicked", self.mounts_callback,6)
		box2.pack_start(self.mount_buttons[6], False, False, 0)
		self.mount_buttons[6].show()

		# Button for BC.1,2
		self.mount_buttons[7].connect("clicked", self.mounts_callback,7)
		box2.pack_start(self.mount_buttons[7], False, False, 0)
		self.mount_buttons[7].show()	

		# Button for BC.2,3
		self.mount_buttons[8].connect("clicked", self.mounts_callback,8)
		box2.pack_start(self.mount_buttons[8], False, False, 0)
		self.mount_buttons[8].show()

		# Button for BC.3,4
		self.mount_buttons[9].connect("clicked", self.mounts_callback,9)
		box2.pack_start(self.mount_buttons[9], False, False, 0)
		self.mount_buttons[9].show()

		# Button for BC.4,5
		self.mount_buttons[10].connect("clicked", self.mounts_callback,10)
		box2.pack_start(self.mount_buttons[10], False, False, 0)
		self.mount_buttons[10].show()

		# Button for BC.5,6
		self.mount_buttons[11].connect("clicked", self.mounts_callback,11)
		box2.pack_start(self.mount_buttons[11], False, False, 0)
		self.mount_buttons[11].show()

		table.attach(box,0,1,1,2,gtk.FILL,0,0,0)
		table.attach(box2,1,2,1,2,gtk.FILL,0,0,0)

		# Adds separator between button field and control panel
		separator = gtk.VSeparator()
        	separator.set_size_request(20, 200)
        	table.attach(separator, 2, 3, 1, 2, gtk.FILL, 0, 0, 0);
		self.window.show_all()
	
		# Create Arrow buttons
		self.arrow_buttons = self.create_arrow_buttons()

		self.control_panel = gtk.Table(6,4, False)

		# Up Arrow of control panel
		#arrow_buttons, x_pos, y_pos = self.create_arrow_buttons('up')
		self.control_panel.attach(self.arrow_buttons[2], 2,3,0,1, 0,0,0,0)
		self.arrow_buttons[2].connect("clicked", self.push_to_move_callback,'up')
		self.arrow_buttons[2].add(self.upblack)
		self.upblack.show()
		

		# Down Arrow of control panel
		self.control_panel.attach(self.arrow_buttons[3], 2,3,2,3, 0,0,0,0)		
		self.arrow_buttons[3].connect("clicked", self.push_to_move_callback,'down')
		self.arrow_buttons[3].add(self.downblack)
		self.downblack.show()
		
		# Right Arrow of control panel
		self.control_panel.attach(self.arrow_buttons[1],3,4,1,2,0,0,0,0)				
		self.arrow_buttons[1].connect("clicked", self.push_to_move_callback,'right')
		self.arrow_buttons[1].add(self.rightblack)
		self.rightblack.show()

		# Left Arrow of control panel
		self.control_panel.attach(self.arrow_buttons[0], 1,2,1,2, 0,0,0,0)		
		self.arrow_buttons[0].connect("clicked", self.push_to_move_callback,'left')
		self.arrow_buttons[0].add(self.leftblack)
		self.leftblack.show()

		self.entry = []
		self.entrySteps = []


		# Label for selected Picomotor
		self.entry.append(gtk.Entry())
		self.entry[0].set_size_request(80,20)
		self.entry[0].set_text(picoData.label)
		self.entry[0].set_editable(False)		
		self.frame0 = gtk.Frame("Active Picomotor")
		self.frame0.add(self.entry[0])
		self.control_panel.attach(self.frame0, 0,1,0,1, gtk.FILL,0,0,0)
		
		# Step Size on X Axis
		self.entry.append(gtk.Entry())
		self.entry[1].set_size_request(60,20)
		#self.entry[1].set_text("not done")
		self.entry[1].set_editable(True)
		self.frame1 = gtk.Frame("X Axis Step Size")
		self.frame1.add(self.entry[1])
		self.control_panel.attach(self.frame1, 0,1,4,5, gtk.FILL,gtk.FILL,0,0)
		self.entry[1].connect("activate",self.update_step_callback, 'X')
		self.entry[1].connect("changed", self.changed, 'X')

		# Step Size on Y Axis
		self.entry.append(gtk.Entry())
		self.entry[2].set_size_request(60,20)
		#self.entry[2].set_text("not done")
		self.entry[2].set_editable(True)
		self.frame2 = gtk.Frame("Y Axis Step Size")
		self.frame2.add(self.entry[2])
		self.control_panel.attach(self.frame2, 0,1,5,6, gtk.FILL,0,0,0)
		self.entry[2].connect("activate",self.update_step_callback, 'Y')
		self.entry[2].connect("changed", self.changed, 'Y')

		# Updated Step Indicators
		self.xindicator = indicators.makeIcon('xg')
		self.yindicator = indicators.makeIcon('yg')
		self.control_panel.attach(self.xindicator, 1,2,4,5,gtk.FILL |gtk.EXPAND,gtk.FILL |gtk.EXPAND,0,0)
		self.control_panel.attach(self.yindicator, 1,2,5,6,0,0,0,0)
		self.yindicator.show()
		self.xindicator.show()
		
		# Step Size Double Button
		self.double_button = gtk.Button("2X Step Size")
		self.control_panel.attach(self.double_button, 0,1,3,4,gtk.FILL,0,0,0)
		self.double_button.show()
		self.double_button.connect("clicked",self.step_button_callback, 'double')

		# Step Size Half Button
		self.half_button = gtk.Button("1/2X Step Size")
		self.control_panel.attach(self.half_button, 0,1,2,3,gtk.FILL,0,0,0)
		self.half_button.show()
		self.half_button.connect("clicked",self.step_button_callback, 'half')
		

		# y position indicator
		self.entry.append(gtk.Entry())
		self.entry[3].set_size_request(80,20)
		self.entry[3].set_text(str(self.ypos))
		self.entry[3].set_editable(False)		
		self.frame3 = gtk.Frame("Y Position")
		self.frame3.add(self.entry[3])
		self.control_panel.attach(self.frame3, 2,4,5,6, 0,0,0,0)

		# x position indicator
		self.entry.append(gtk.Entry())
		self.entry[4].set_size_request(80,20)
		self.entry[4].set_text(str(self.xpos))
		self.entry[4].set_editable(False)		
		self.frame4 = gtk.Frame("X Position")
		self.frame4.add(self.entry[4])
		self.control_panel.attach(self.frame4, 2,4,4,5, 0,0,0,0)

		# Zeroing menu
		self.zerobar = gtk.MenuBar()
		subzero = gtk.Menu()
		zeroitem = gtk.MenuItem("Zero")
        	all = gtk.MenuItem("All")
        	x = gtk.MenuItem("X axis")
		y = gtk.MenuItem("Y axis")
		subzero.append(all)
		subzero.append(x)
		subzero.append(y)
		zeroitem.set_submenu(subzero)
		self.zerobar.append(zeroitem)
		self.control_panel.attach(self.zerobar, 2,3,3,4,0,0,0,0)
		self.zerobar.show() 
		
		# Zeroing menu Callbacks
		all.connect("activate",self.zero_callback, 'all')
		x.connect("activate",self.zero_callback, 'x')
		y.connect("activate",self.zero_callback, 'y')

		table.attach(self.control_panel,3,4,1,2,gtk.FILL,0,0,0)
		
	# Callback for changed step size
	def changed(self, widget, which):
		print which
		if which == 'X':
			pointer = 1		
		if which == 'Y':
			pointer = 2
		text = (self.entry[pointer].get_text())
		print text
		test = self.character_test(text)
		
		if self.firsttime == False:
			if test == False: 
				if which == 'X':
					
					self.xindicator.unmap()
					self.xindicator = indicators.makeIcon('xy')
					self.control_panel.attach(self.xindicator, 1,2,4,5,gtk.FILL |gtk.EXPAND,gtk.FILL |gtk.EXPAND,0,0)
					self.xindicator.show()
					flag = 1
					if self.xcol == 'black':
						print "no enter: x black to yellow"
						self.arrow_buttons[0].remove(self.leftblack)
						self.arrow_buttons[1].remove(self.rightblack)
						self.arrow_buttons[0].add(self.leftyellow)
						self.arrow_buttons[1].add(self.rightyellow)
						self.leftyellow.show()
						self.rightyellow.show()
						self.xcol = 'yellow'

					if self.xcol == 'red':
						print "no enter: x red to yellow"
						self.arrow_buttons[0].remove(self.leftred)
						self.arrow_buttons[1].remove(self.rightred)
						self.arrow_buttons[0].add(self.leftyellow)
						self.arrow_buttons[1].add(self.rightyellow)
						self.leftyellow.show()
						self.rightyellow.show()
						self.xcol = 'yellow'

				elif which == 'Y':
					print "passing y"
					print self.ycol
					self.yindicator.unmap()
					self.yindicator = indicators.makeIcon('yy')
					self.control_panel.attach(self.yindicator, 1,2,5,6,0,0,0,0)
					self.yindicator.show()
					flag = 1
					if self.ycol == 'black':
						print self.ycol
						print "no enter: y black to yellow"
						print "yes it is getting here."				
						self.arrow_buttons[2].remove(self.upblack)
						self.arrow_buttons[3].remove(self.downblack)
						self.arrow_buttons[2].add(self.upyellow)
						self.arrow_buttons[3].add(self.downyellow)
						self.upyellow.show()
						self.downyellow.show()
						self.ycol = 'yellow'
						print self.ycol
					if self.ycol == 'red':

						print "no enter: y red to yellow"
						self.arrow_buttons[2].remove(self.upred)
						self.arrow_buttons[3].remove(self.downred)
						self.arrow_buttons[2].add(self.upyellow)
						self.arrow_buttons[3].add(self.downyellow)
						self.upyellow.show()
						self.downyellow.show()		
						self.ycol = 'yellow'


			else:
				if which == 'X':
					
					self.xindicator.unmap()
					self.xindicator = indicators.makeIcon('xr')
					self.control_panel.attach(self.xindicator, 1,2,4,5, gtk.FILL | gtk.EXPAND, gtk.FILL | gtk.EXPAND,0,0)
					self.xindicator.show()
					print self.xcol
					if self.xcol == 'black':
						print "no enter: x black to red failed test" 
						self.arrow_buttons[0].remove(self.leftblack)
						self.arrow_buttons[1].remove(self.rightblack)
						self.arrow_buttons[0].add(self.leftred)
						self.arrow_buttons[1].add(self.rightred)
						self.leftred.show()
						self.rightred.show()
						self.xcol = 'red'

					if self.xcol == 'yellow':
						print "no enter: x yellow to red failed test"
						self.arrow_buttons[0].remove(self.leftyellow)
						self.arrow_buttons[1].remove(self.rightyellow)
						self.arrow_buttons[0].add(self.leftred)
						self.arrow_buttons[1].add(self.rightred)
						self.leftred.show()
						self.rightred.show()	
						self.xcol = 'red'

				if which == 'Y':
					self.yindicator.unmap()
					self.yindicator = indicators.makeIcon('yr')
					self.control_panel.attach(self.yindicator, 1,2,5,6,0,0,0,0)
					self.yindicator.show()

					if self.ycol == 'black':
						print "no enter: y black to red failed test"
						self.arrow_buttons[2].remove(self.upblack)
						self.arrow_buttons[3].remove(self.downblack)
						self.arrow_buttons[2].add(self.upred)
						self.arrow_buttons[3].add(self.downred)
						self.upred.show()
						self.downred.show()
						self.ycol = 'red'

					if self.ycol == 'yellow':
						print "no enter: y yellow to red failed test"
						self.arrow_buttons[2].remove(self.upyellow)
						self.arrow_buttons[3].remove(self.downyellow)
						self.arrow_buttons[2].add(self.upred)
						self.arrow_buttons[3].add(self.downred)
						self.upred.show()
						self.downred.show()
						self.ycol = 'red'




		else: 
			if self.count >= 2:
				self.firsttime = False
			else:
				self.count = self.count + 1
	# Zero callback
	def zero_callback(self, widget, which):
		if which == 'x':
			self.xpos = 0
			self.entry[4].set_text(str(self.xpos))

		if which == 'y':
			self.ypos = 0
			self.entry[3].set_text(str(self.ypos))

		if which == 'all':	
			self.xpos = 0
			self.ypos = 0
			self.entry[4].set_text(str(self.xpos))
			self.entry[3].set_text(str(self.ypos))



	# Step Size Double Button Callback
	def step_button_callback(self, widget, increment):
		if increment == 'half':
			self.steps[0] = self.steps[0] * .5
			self.steps[1] = self.steps[1] * .5
			self.entry[1].set_text(str(self.steps[0]))
			self.entry[2].set_text(str(self.steps[1]))

		if increment == 'double':
			self.steps = self.steps * 2
			self.entry[1].set_text(str(self.steps[0]))
			self.entry[2].set_text(str(self.steps[1]))
		self.update_step_callback(widget, 'X')
		self.update_step_callback(widget, 'Y')
		

	# Moves picomotor at push of arrow button.
	def push_to_move_callback(self, widget, axis):
		print axis
		if self.ycol != 'red':
			if axis == 'up':
				self.MoveRelative(self.driver[1],self.motor[1],-self.steps[1])
				self.ypos += self.steps[1]
				self.entry[3].set_text(str(self.ypos))
				picoData.location[self.index[1]] = self.ypos
			if axis == 'down':
				self.MoveRelative(self.driver[1],self.motor[1],self.steps[1])		
				self.ypos -= self.steps[1]
				self.entry[3].set_text(str(self.ypos))
				picoData.location[self.index[1]] = self.ypos
		if self.xcol != 'red':
			if axis == 'left':
				self.MoveRelative(self.driver[0],self.motor[0],self.steps[0])
				self.xpos -= self.steps[0]
				self.entry[4].set_text(str(self.xpos))
				picoData.location[self.index[0]] = self.xpos
			if axis == 'right':
				self.MoveRelative(self.driver[0],self.motor[0], -self.steps[0])
				self.xpos += self.steps[0]
				self.entry[4].set_text(str(self.xpos))
				print picoData.location[self.index[0]]
				picoData.location[self.index[0]] = self.xpos
				print picoData.location[self.index[0]]
	

	# Sets label on picomotor selection and Loads control of selected picomotor.
	def mounts_callback(self, widget, num):
		
		if self.mode == 'control':
			self.window.show_all()
		picoData.label = picoData.picoId.field('picoId')[num*2]
		self.entry[0].set_text(picoData.label)
		picoName = picoData.label
		picoIP = picoData.getFieldValue(picoData.picoId, 'IP', 'picoId', picoName)
        	index, = picoData.picoId.field('picoId').match(picoName)
        	nAxis = len(index)
		self.index = index
		self.xpos = picoData.location[index[0]]
		self.ypos = picoData.location[index[1]]
		self.entry[4].set_text(str(picoData.location[index[0]]))
		self.entry[3].set_text(str(picoData.location[index[1]]))

		self.driver = picoData.picoId.field('driver')[index]
		self.motor = picoData.picoId.field('motor')[index]
		self.steps = PicoLib.array([500]*nAxis)
		self.Relative = PicoLib.zeros(nAxis)
		#if self.mode == 'mapping':
		print "picoName = ", picoName
        	print "available axis: ", picoData.picoId.field('axis')[index]
		print "picoIP = ", picoIP
		print self.motor

		# Intialization of the telnet connection with the picoMotor
        	if picoData.select_Flag == False:
			picoLowLevel.PicoControl.__init__(self, picoIP)	
      			print "self.tn.host = ", self.tn.host
		for i in range(nAxis):
	        	self.SetVelocity(self.driver[i], self.motor[i], 2000)
		self.entry[1].set_text(str(self.steps[0]))
		self.entry[2].set_text(str(self.steps[1]))
		picoData.select_Flag = True
		self.update_step_callback(widget, 'X')
		self.update_step_callback(widget, 'Y')
	
		

	# Create icons for mounts to place on buttons
	def create_mount_buttons(self):
		mount_buttons = []
		x_pos = [0, 0, 0, 0]
		y_pos = [0, 0, 0, 0]
		for n in range(12):	
			mount_buttons.append(gtk.Button())
			if n < 6:
				image = mounts.makeIcon('right')
			else:
				image = mounts.makeIcon('left')
			mount_buttons[n].add(image)
		x_pos = [0, 0, 0, 0]
		y_pos = [0, 0, 0, 0]
		return mount_buttons, x_pos, y_pos

	# Create icons for arrows to place on buttons
	def create_arrow_buttons(self):
		
		arrow_buttons = []
		x_pos = [0, 0, 0, 0]
		y_pos = [0, 0, 0, 0]
		
	
		# left arrow icon black
		arrow_buttons.append(gtk.Button())
		self.leftblack = arrows.makeIcon('left')
		
		# right arrow icon black
		arrow_buttons.append(gtk.Button())
		self.rightblack = arrows.makeIcon('right')
		
		#  up arrow icon black
		arrow_buttons.append(gtk.Button())
		self.upblack = arrows.makeIcon('up')
		
		# down arrow icon black
		arrow_buttons.append(gtk.Button())
		self.downblack = arrows.makeIcon('down')
		
		# left arrow icon red
		self.leftred = arrows.makeIcon('leftr')
		
		# right arrow icon red 
		self.rightred = arrows.makeIcon('rightr')
		
		# up arrow icon red
		self.upred = arrows.makeIcon('upr')
	
		# down arrow icon red
		self.downred = arrows.makeIcon('downr')
		
		# left arrow icon yellow
		self.leftyellow = arrows.makeIcon('lefty')
		
		# right arrow icon yellow
		self.rightyellow = arrows.makeIcon('righty')
		
		# up arrow icon yellow
		self.upyellow = arrows.makeIcon('upy')
		
		# down arrow icon yellow
		self.downyellow = arrows.makeIcon('downy')
		
		x_pos = [0, 0, 0, 0]
		y_pos = [0, 0, 0, 0]
		
		return arrow_buttons
	
	# Updates step size when enter is pressed in the text box	
	def update_step_callback(self, widget, axis):
		if axis == 'X':
			pointer = 1		
		if axis == 'Y':
			pointer = 2
		text = (self.entry[pointer].get_text())
		test = self.character_test(text)
		if test == False:
			ntext = int(text)
			print ntext
			if 0 < ntext <= 1000 :
				if axis == 'X':
					self.xindicator.unmap()
					self.xindicator = indicators.makeIcon('xg')
					self.control_panel.attach(self.xindicator, 1,2,4,5,gtk.FILL |gtk.EXPAND,gtk.FILL |gtk.EXPAND,0,0)
					self.xindicator.show()

					if self.xcol == 'yellow':
						print "x yellow to black failed test"
						self.arrow_buttons[0].remove(self.leftyellow)
						self.arrow_buttons[1].remove(self.rightyellow)
						self.arrow_buttons[0].add(self.leftblack)
						self.arrow_buttons[1].add(self.rightblack)
						self.leftblack.show()
						self.rightblack.show()
						self.xcol = 'black'

					if self.xcol == 'red':
						print "x red to black"
						self.arrow_buttons[0].remove(self.leftred)
						self.arrow_buttons[1].remove(self.rightred)
						self.arrow_buttons[0].add(self.leftblack)
						self.arrow_buttons[1].add(self.rightblack)
						self.leftblack.show()
						self.rightblack.show()
						self.xcol = 'black'
						
				if axis == 'Y':
					self.yindicator.unmap()
					self.yindicator = indicators.makeIcon('yg')
					self.control_panel.attach(self.yindicator, 1,2,5,6,0,0,0,0)
					self.yindicator.show()

					if self.ycol == 'yellow':
						print "y yellow to black"
						self.arrow_buttons[2].remove(self.upyellow)
						self.arrow_buttons[3].remove(self.downyellow)
						self.arrow_buttons[2].add(self.upblack)
						self.arrow_buttons[3].add(self.downblack)
						self.upblack.show()
						self.downblack.show()
						self.ycol = 'black'	
	
					if self.ycol == 'red':
						print "y red to black"
						self.arrow_buttons[2].remove(self.upred)
						self.arrow_buttons[3].remove(self.downred)
						self.arrow_buttons[2].add(self.upblack)
						self.arrow_buttons[3].add(self.downblack)
						self.upblack.show()
						self.downblack.show()
						self.ycol = 'black'
						self.ycol = 'black'		

				newsteps = self.entry[pointer].get_text()
				
				self.steps[pointer-1] = int(newsteps)
				
				print "New step size: %d\n" % self.steps[pointer-1]
			else:	
				if axis == 'X':
					self.xindicator.unmap()
					self.xindicator = indicators.makeIcon('xr')
					self.control_panel.attach(self.xindicator, 1,2,4,5,gtk.FILL |gtk.EXPAND,gtk.FILL |gtk.EXPAND,0,0)
					self.xindicator.show()

					if self.xcol == 'black':
						print "out of range, x black to red"
						self.arrow_buttons[0].remove(self.leftblack)
						self.arrow_buttons[1].remove(self.rightblack)
						self.arrow_buttons[0].add(self.leftred)
						self.arrow_buttons[1].add(self.rightred)
						self.leftred.show()
						self.rightred.show()
						self.xcol = 'red'

					if self.xcol == 'yellow':
						print "out of range, x yellow to red"
						self.arrow_buttons[0].remove(self.leftyellow)
						self.arrow_buttons[1].remove(self.rightyellow)
						self.arrow_buttons[0].add(self.leftred)
						self.arrow_buttons[1].add(self.rightred)
						self.leftred.show()
						self.rightred.show()
						self.xcol = 'red'

				if axis == 'Y':
					self.yindicator.unmap()
					self.yindicator = indicators.makeIcon('yr')
					self.control_panel.attach(self.yindicator, 1,2,5,6,0,0,0,0)
					self.yindicator.show()

					if self.ycol == 'black':
						print "out of range, y black to red"
						self.arrow_buttons[2].remove(self.upblack)
						self.arrow_buttons[3].remove(self.downblack)
						self.arrow_buttons[2].add(self.upred)
						self.arrow_buttons[3].add(self.downred)
						self.upred.show()
						self.downred.show()		
						self.ycol = 'red'

					if self.ycol == 'yellow':
						print "out of range, y yellow to red"
						self.arrow_buttons[2].remove(self.upyellow)
						self.arrow_buttons[3].remove(self.downyellow)
						self.arrow_buttons[2].add(self.upred)
						self.arrow_buttons[3].add(self.downred)
						self.upred.show()
						self.downred.show()
						self.ycol = 'red' 

	   	else:	
			if axis == 'X':
				self.xindicator.unmap()
				self.xindicator = indicators.makeIcon('xr')
				self.control_panel.attach(self.xindicator, 1,2,4,5,gtk.FILL |gtk.EXPAND,gtk.FILL |gtk.EXPAND,0,0)
				self.xindicator.show()

				if self.xcol == 'black':
					print "failed test, x black to red"
					self.arrow_buttons[0].remove(self.leftblack)
					self.arrow_buttons[1].remove(self.rightblack)
					self.arrow_buttons[0].add(self.leftred)
					self.arrow_buttons[1].add(self.rightred)
					self.leftred.show()
					self.rightred.show()
					self.xcol = 'red'
				if self.xcol == 'yellow':
					print "failed test, x yellow to red"
					self.arrow_buttons[0].remove(self.leftyellow)
					self.arrow_buttons[1].remove(self.rightyellow)
					self.arrow_buttons[0].add(self.leftred)
					self.arrow_buttons[1].add(self.rightred)
					self.leftred.show()
					self.rightred.show()
					self.xcol = 'red'


			if axis == 'Y':
				self.yindicator.unmap()
				self.yindicator = indicators.makeIcon('yr')
				self.control_panel.attach(self.yindicator, 1,2,5,6,0,0,0,0)
				self.yindicator.show()

				
				if self.ycol == 'black':
					print "failed test, y black to red"
					self.arrow_buttons[2].remove(self.upblack)
					self.arrow_buttons[3].remove(self.downblack)
					self.arrow_buttons[2].add(self.upred)
					self.arrow_buttons[3].add(self.downred)
					self.upred.show()
					self.downred.show()		
					self.ycol = 'red'
				if self.ycol == 'yellow':
					print "failed test, y yellow to red"
					self.arrow_buttons[2].remove(self.upyellow)
					self.arrow_buttons[3].remove(self.downyellow)
					self.arrow_buttons[2].add(self.upred)
					self.arrow_buttons[3].add(self.downred)
					self.upred.show()
					self.downred.show()
					self.ycol = 'red' 


	
#	def mode_change(self, widget, mode):
#		if mode == 'cont':
#			self.mode = 'control'
#			self.arrow_buttons[0].show()
#			self.arrow_buttons[1].show()
#			self.arrow_buttons[2].show()
#			self.arrow_buttons[3].show()
#			self.entry[0].show()
#			self.entry[1].show()
#			self.entry[2].show()
#			self.frame0.show()
#			self.frame1.show()
#			self.frame2.show()
#			self.frame3.hide()
#		if mode == 'joy':
#			self.mode = 'mapping'
#			self.arrow_buttons[0].hide()
#			self.arrow_buttons[0].unmap()
#			self.arrow_buttons[1].hide()
#			self.arrow_buttons[1].unmap()
#			self.arrow_buttons[2].hide()
#			self.arrow_buttons[2].unmap()
#			self.arrow_buttons[3].hide()
#			self.arrow_buttons[3].unmap()
#			self.entry[0].hide()
#			self.entry[0].unmap()
#			self.entry[1].hide()
#			self.entry[1].unmap()
#			self.entry[2].hide()
#			self.entry[2].unmap()
#			self.frame0.hide()
#			self.frame0.unmap()
#			self.frame1.hide()
#			self.frame1.unmap()
#			self.frame2.hide()
#			self.frame2.unmap()
#			self.frame3.show()
			
	def character_test(self, string):
		i=0
		flag = False
		while i <= len(string):
			if string[i-1:i] == "0":
				flag = False
			elif string[i-1:i] == "1":
				flag = False
			elif string[i-1:i] == "2":
				flag = False
			elif string[i-1:i] == "3":
				flag = False
			elif string[i-1:i] == "4":
				flag = False
			elif string[i-1:i] == "5":
				flag = False
			elif string[i-1:i] == "6":
				flag = False
			elif string[i-1:i] == "7":
				flag = False
			elif string[i-1:i] == "8":
				flag = False
			elif string[i-1:i] == "9":
				flag = False
			else:
				flag = True
			i=i+1
		print flag
		return flag


	def main(self):
		gtk.main()		

if __name__ == "__main__":
	base=Base()	
	base.main()
